//=============================================================================
// CampPartyWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "CampPartyWindow.h"
#include "DataManager.h"
#include "PlayerParty.h"
#include "PlayerChar.h"
#include "CampWindow.h"
#include "Manipulator.h"

// J[\ʒu킹Ɏgp
const stMenuItem PARTY_MENU_ITEM[] = {
	{   0,  TRUE,	20,  43, "", 0, 0 },
	{   1,  TRUE,	20,  98, "", 0, 0 },
	{   2,  TRUE,	20, 153, "", 0, 0 },
	{   3,  TRUE,	20, 208, "", 0, 0 },
};

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CCampPartyWindow::CCampPartyWindow(void)
	: m_bSelected( FALSE ), m_nMode( PARTY_WND_MODE_NORMAL )
{
	m_nType = MENU_TYPE_VERTICAL;	// c^j[
	m_bLoopAtEdge = TRUE;			// ACen_ƏI_q
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CCampPartyWindow::~CCampPartyWindow(void)
{
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CCampPartyWindow::Create( CPlayerParty *pPlayerParty, CCampWindow *pParent )
{
	BOOL bRet = CMenuWindow::Create( 0, 0, CANVAS_WIDTH, CANVAS_HEIGHT );

	m_pCampWnd = pParent;
	m_pPlayerParty = pPlayerParty;

	// ACeǉ
	for ( int iCnt = 0; iCnt < sizeof( PARTY_MENU_ITEM ) / sizeof( PARTY_MENU_ITEM[0] ); iCnt ++ )
	{
		AddMenuItem( &PARTY_MENU_ITEM[iCnt] );
	}

	return bRet;
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CCampPartyWindow::FrameMove( const CManipulator *pMani )
{
	CMenuWindow::FrameMove( pMani );

	if ( !m_bFocused )
		return;

	if ( m_nMode == PARTY_WND_MODE_NORMAL )
	{
		if ( pMani->CheckKey( KEY_INPUT_X ) )
		{
			if ( !m_bSelected )
			{	// IĂȂ  IԂ
				m_bSelected = TRUE;
				m_nSelItem = GetCurPos();

				// IJ[\`ʒuǉ
				stMenuItem *pItem = GetItem( m_nSelItem );
				m_pCursor->AddSelectedPos( pItem->nPosX-12, pItem->nPosY-3 );
			}
			else
			{	// IĂ
				ProcDecideKey();
				m_pCursor->RemoveAllSelectedPos();	// IԏI
				m_bSelected = FALSE;
			}
		}
		if ( pMani->CheckKey( KEY_INPUT_Z ) )
		{
			if ( m_bSelected )
			{	// IĂ
				m_pCursor->RemoveAllSelectedPos();	// IԏI
				m_bSelected = FALSE;
			}
			else
			{	// tH[JXj[ɖ߂
				m_pCampWnd->HideFormationWindow();
			}
		}
	}
	else
	{	// ΏۑI[h
		if ( pMani->CheckKey( KEY_INPUT_X ) )
		{
			ProcDecideKey();
			m_pCursor->RemoveAllSelectedPos();	// IԏI
			m_bSelected = FALSE;
		}
		if ( pMani->CheckKey( KEY_INPUT_Z ) )
		{
			m_pCampWnd->NotifyCancelKey( this );
		}
	}
}
//-----------------------------------------------------------------------------
// L[
//-----------------------------------------------------------------------------
void CCampPartyWindow::ProcDecideKey( void )
{
	if ( m_nMode == PARTY_WND_MODE_NORMAL )
	{
		if ( m_nSelItem == GetCurPos() )
		{	// IJnƓƂŌL[  Oqqؑ
			CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer( m_nSelItem );
			if ( pPlayer->m_CharInfo.nBtlPos == BATTLE_POS_FRONT )
			{
				pPlayer->m_CharInfo.nBtlPos = BATTLE_POS_BACK;
			}
			else
			{
				pPlayer->m_CharInfo.nBtlPos = BATTLE_POS_FRONT;
			}
		}
		else
		{	// IJnƈႤƂŌL[  ʒuւ
			m_pPlayerParty->SwapPlayer( m_nSelItem, GetCurPos() );
		}
	}
	else
	{
		// L[ʒm
		m_pCampWnd->NotifyDecideKey( this, GetCurPos() );

		// ʏ탂[h
		m_nMode = PARTY_WND_MODE_NORMAL;
	}
}

//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
void CCampPartyWindow::Render( void )
{
	CMenuWindow::Render();

	const int BASE_POS_Y_0 = 35;
	const int BASE_POS_Y_1 = 90;
	const int BASE_POS_Y_2 =145;
	const int BASE_POS_Y_3 =200;
	// LGʒu
	const POSITION PosPortrate[] = {
		{	20, BASE_POS_Y_0 },
		{	20, BASE_POS_Y_1 },
		{	20, BASE_POS_Y_2 },
		{	20, BASE_POS_Y_3 },
	};
	// Oʒu
	const POSITION PosName[] = {
		{	20, BASE_POS_Y_0 - 20 },
		{	20, BASE_POS_Y_1 - 20 },
		{	20, BASE_POS_Y_2 - 20 },
		{	20, BASE_POS_Y_3 - 20 },
	};
	// Wuʒu
	const POSITION PosJobName[] = {
		{	95, BASE_POS_Y_0 - 20 },
		{	95, BASE_POS_Y_1 - 20 },
		{	95, BASE_POS_Y_2 - 20 },
		{	95, BASE_POS_Y_3 - 20 },
	};
	// LVʒu
	const POSITION PosLv[] = {
		{	25, BASE_POS_Y_0 - 9 },
		{	25, BASE_POS_Y_1 - 9 },
		{	25, BASE_POS_Y_2 - 9 },
		{	25, BASE_POS_Y_3 - 9 },

	};
	// HPʒu
	const POSITION PosHp[] = {
		{  110, BASE_POS_Y_0 + 7 },
		{  110, BASE_POS_Y_1 + 7 },
		{  110, BASE_POS_Y_2 + 7 },
		{  110, BASE_POS_Y_3 + 7 },
	};
	// MPʒu
	const POSITION PosMp[] = {
		{  110, BASE_POS_Y_0 + 16 },
		{  110, BASE_POS_Y_1 + 16 },
		{  110, BASE_POS_Y_2 + 16 },
		{  110, BASE_POS_Y_3 + 16 },
	};

	CDataManager *pDataMan = CDataManager::GetInstance();
	const char *lpzText;
	char szBuff[64];
	// p[eB`
	for ( int iCnt = 0; iCnt < m_pPlayerParty->GetPlayerCount(); iCnt ++ )
	{
		CPlayerChar *pPlayer = m_pPlayerParty->GetPlayer(iCnt);

		// LG
		if ( pPlayer->m_CharInfo.nBtlPos == BATTLE_POS_FRONT )
			m_pPlayerParty->RenderPortrate( iCnt, PosPortrate[iCnt].nPosX, PosPortrate[iCnt].nPosY );		// Oq
		else
			m_pPlayerParty->RenderPortrate( iCnt, PosPortrate[iCnt].nPosX + 20, PosPortrate[iCnt].nPosY );	// q

		// O
		lpzText = pPlayer->m_CharInfo.szName;
		if ( strlen(lpzText) == 0 )
			lpzText = "?";
		DrawString( PosName[iCnt].nPosX, PosName[iCnt].nPosY, lpzText, STRING_COLOR );

		// Wu
		lpzText = pDataMan->GetJobName( pPlayer->m_CharInfo.nJobID );
		DrawString( PosJobName[iCnt].nPosX, PosJobName[iCnt].nPosY, lpzText, STRING_COLOR );

		// x
		sprintf_s( szBuff, "ku %4d" ,pPlayer->m_CharInfo.nLV );	lpzText = szBuff;
		DrawString( PosLv[iCnt].nPosX, PosLv[iCnt].nPosY, lpzText, STRING_COLOR );

		// HP
		sprintf_s( szBuff, "go@%4d ^ %4d" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
		//sprintf_s( szBuff, "go@9999 ^ 9999" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
		DrawString( PosHp[iCnt].nPosX, PosHp[iCnt].nPosY, lpzText, STRING_COLOR );

		// MP
		sprintf_s( szBuff, "lo@%4d ^ %4d" ,pPlayer->m_CharInfo.nMP, pPlayer->m_BasePram.nMaxMP );	lpzText = szBuff;
		//sprintf_s( szBuff, "lo@9999 ^ 9999" ,pPlayer->m_CharInfo.nHP, pPlayer->m_BasePram.nMaxHP );	lpzText = szBuff;
		DrawString( PosMp[iCnt].nPosX, PosMp[iCnt].nPosY, lpzText, STRING_COLOR );
	}

	// I _ŃJ[\`
	if ( m_bSelected )
	{
		m_pCursor->RenderSelectedCursor();
		m_pCursor->Render();
	}

}
