//=============================================================================
// Effect.cpp
//=============================================================================
#include "Stdinc.h"
#include "Effect.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEffect::CEffect(void)
	:m_nFlameCnt( 0 ), m_nShakeOffset( 0 ), m_nEffectType( EFFECT_TYPE_NONE )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEffect::~CEffect(void)
{
}
//-----------------------------------------------------------------------------
// StartFadeout
//-----------------------------------------------------------------------------
void CEffect::StartFadeout( DWORD dwFadeColor, UINT nFameCnt )
{
	m_nStartFlameCnt = m_nFlameCnt = nFameCnt;
	m_dwFadeColor = dwFadeColor;

	m_nEffectType = EFFECT_TYPE_FADE_OUT;
}
//-----------------------------------------------------------------------------
// StartFadein
//-----------------------------------------------------------------------------
void CEffect::StartFadein( DWORD dwFadeColor, UINT nFameCnt )
{
	m_nStartFlameCnt = m_nFlameCnt = nFameCnt;
	m_dwFadeColor = dwFadeColor;

	m_nEffectType = EFFECT_TYPE_FADE_IN;
}
//-----------------------------------------------------------------------------
// StartShake
//-----------------------------------------------------------------------------
void CEffect::StartShake( int Type, UINT nFrame, double dblSpeed, int nScale )
{
	const int SHAKE_V = 0;
	const int SHAKE_H = 1;

	if ( Type == SHAKE_V )
		m_nEffectType = EFFECT_TYPE_V_SHAKE;
	else 
		m_nEffectType = EFFECT_TYPE_H_SHAKE;

	m_nStartFlameCnt = m_nFlameCnt = nFrame;

	m_dblShakeSpeed = dblSpeed;
	m_nShakeScale = nScale;

}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CEffect::FrameMove( void )
{
	if ( m_nFlameCnt <= 0 )
		return;

	m_nFlameCnt --;
}
#include <math.h>
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CEffect::Render( void )
{
	if ( m_nFlameCnt <= 0 )
	{
		m_nShakeOffset = 0;
		return;
	}

	int nRate = (int)((double)m_nFlameCnt * 255.0 / (double)m_nStartFlameCnt);

	if ( m_nEffectType == EFFECT_TYPE_FADE_IN ||
		 m_nEffectType == EFFECT_TYPE_FADE_OUT )
	{	// tF[hC / tF[hAEg
		if ( m_nEffectType == EFFECT_TYPE_FADE_OUT )
		{
			nRate = 255 - nRate;
		}
		// uh[hݒ
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, nRate );

		// ʑŜɋ``
		DrawBox( 0, 0, CANVAS_WIDTH+1, CANVAS_HEIGHT+1, m_dwFadeColor, TRUE );

		// uh[h߂
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND , 255 );
	}

	else if ( m_nEffectType == EFFECT_TYPE_V_SHAKE ||
			  m_nEffectType == EFFECT_TYPE_H_SHAKE )
	{
		//m_nShakeOffsetX = (int)( sin( m_nFlameCnt / 6.67f ) * 8 );
		m_nShakeOffset = (int)( sin( m_nFlameCnt / m_dblShakeSpeed ) * m_nShakeScale );
	}
}
