//=============================================================================
// Effect.h
//=============================================================================
#pragma once

//-----------------------------------------------------------------------------
// CEffect
//-----------------------------------------------------------------------------
class CEffect
{
protected:
	int		m_nEffectType;

	DWORD	m_dwFadeColor;
	UINT	m_nFlameCnt;
	UINT	m_nStartFlameCnt;

	int		m_nShakeOffset;
	double	m_dblShakeSpeed;
	int		m_nShakeScale;


public:
	CEffect(void);
	virtual ~CEffect(void);

	void StartFadeout( DWORD dwFadeColor, UINT nFameCnt );
	void StartFadein( DWORD dwFadeColor, UINT nFameCnt );
	void StartShake( int Type, UINT nFrame, double dblSpeed, int nScale );

	void FrameMove( void ); 	// XV
	void Render( void );		// `

	BOOL IsExecuting( void ) const
	{	return m_nFlameCnt;	};

	int GetShakeOffsetX( void ) const
	{	
		if ( m_nEffectType == EFFECT_TYPE_V_SHAKE )
			return 0;
		else if ( m_nEffectType == EFFECT_TYPE_H_SHAKE )
			return m_nShakeOffset;
		else 
			return 0;
	};
	int GetShakeOffsetY( void ) const
	{	
		if ( m_nEffectType == EFFECT_TYPE_H_SHAKE )
			return 0;
		else if ( m_nEffectType == EFFECT_TYPE_V_SHAKE )
			return m_nShakeOffset;
		else 
			return 0;
	};
};
