//=============================================================================
// FrameWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "FrameWindow.h"
#include "DataManager.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CFrameWindow::CFrameWindow(void)
: m_nPosX( 0 ), m_nPosY( 0 ), m_nWidth( CANVAS_WIDTH ), m_nHeight( CANVAS_HEIGHT ), 
  m_bProgressVisible( FALSE ), m_bExtendBackGround( TRUE ), m_nFrameCnt( 0 )
{
	m_bIsVisible = FALSE;
	ZeroMemory( m_nHandle, sizeof(m_nHandle) );
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CFrameWindow::~CFrameWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
// 
//-----------------------------------------------------------------------------
BOOL CFrameWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight )
{
	// EBhËʒu
	m_nPosX = iPosX;
	m_nPosY = iPosY;

	// EBhẼTCY
	m_nWidth = iWidth;
	m_nHeight= iHeight;


	// 摜Ǎ
	if ( !CDataManager::GetInstance()->LoadFrameWndGraph() )
	{
		return FALSE;
	}

	CDataManager::GetInstance()->GetFrameWndGraph( m_nHandle );

	return TRUE;
}
//-----------------------------------------------------------------------------
// Delete
//-----------------------------------------------------------------------------
void CFrameWindow::Delete( void )
{
}

//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CFrameWindow::FrameMove( void )
{
	if ( 0 < m_nFrameCnt )
	{// Aj[V
		-- m_nFrameCnt;
	}
	// Aj[VI
	else if ( m_nFrameCnt <= 0 )
	{
		m_bIsVisible = m_bProgressVisible;
	}
}

//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CFrameWindow::Render( void )
{
	if ( !m_bIsVisible )
		return ;

	// wi
	if ( m_bExtendBackGround )
	{
		DrawExtendGraphEx( m_nPosX, m_nPosY, m_nPosX + m_nWidth, m_nPosY + m_nHeight, m_nHandle[ BACK_GROUND ], FALSE );
	}
	else
	{
		// kȂ̂܂܂̃OfwiG؂ʂĕ`
		DrawRectGraphEx( m_nPosX, m_nPosY,		// Tgt
						 m_nPosX, m_nPosY,		// Src Pos
						 m_nWidth,m_nHeight,	// Src Size
						 m_nHandle[ BACK_GROUND ], FALSE, FALSE );

	}

	// g`
	RenderFrame();
}
//-----------------------------------------------------------------------------
// RenderFrame
//-----------------------------------------------------------------------------
void CFrameWindow::RenderFrame( void )
{
	if ( !m_bIsVisible )
		return ;

	int iCountH = m_nWidth / FRAME_CHIP_ONE_SIDE_SIZE;		// `bv
	int iCountV = m_nHeight / FRAME_CHIP_ONE_SIDE_SIZE;		// `bv

	for ( int iCnt = 0; iCnt < iCountH; iCnt ++ )
	{
		int iPosX = m_nPosX + ( iCnt * FRAME_CHIP_ONE_SIDE_SIZE );
		// 
		DrawGraphEx( iPosX, m_nPosY , m_nHandle[ T_SIDE ], TRUE ) ;
		// 
		DrawGraphEx( iPosX, m_nPosY + m_nHeight - FRAME_CHIP_ONE_SIDE_SIZE , m_nHandle[ B_SIDE ], TRUE ) ;
	}
	// 
	for ( int iCnt = 0; iCnt < iCountV; iCnt ++ )
	{
		int iPosY = m_nPosY + ( iCnt * FRAME_CHIP_ONE_SIDE_SIZE );
		// 
		DrawGraphEx( m_nPosX, iPosY , m_nHandle[ L_SIDE ], TRUE ) ;
		// E
		DrawGraphEx( m_nPosX + m_nWidth - FRAME_CHIP_ONE_SIDE_SIZE, iPosY , m_nHandle[ R_SIDE ], TRUE ) ;
	}

	// 
	DrawGraphEx( m_nPosX , m_nPosY , m_nHandle[ L_T_CORNER ], TRUE ) ;
	// E
	DrawGraphEx( m_nPosX + m_nWidth - FRAME_CHIP_ONE_SIDE_SIZE, m_nPosY , m_nHandle[ R_T_CORNER ], TRUE ) ;
	// 
	DrawGraphEx( m_nPosX , m_nPosY + m_nHeight - FRAME_CHIP_ONE_SIDE_SIZE, m_nHandle[ L_B_CORNER ], TRUE ) ;
	// E
	DrawGraphEx( m_nPosX + m_nWidth - FRAME_CHIP_ONE_SIDE_SIZE, m_nPosY + m_nHeight - FRAME_CHIP_ONE_SIDE_SIZE , m_nHandle[ R_B_CORNER ], TRUE ) ;
}
//-----------------------------------------------------------------------------
// ShowWindow
//-----------------------------------------------------------------------------
void CFrameWindow::ShowWindow( BOOL bFlag )
{
	m_bProgressVisible = bFlag;
	m_nFrameCnt = 10;
}
//-----------------------------------------------------------------------------
// SetVisible
// `
//-----------------------------------------------------------------------------
void CFrameWindow::SetVisible( BOOL bFlag )
{
	m_bIsVisible = m_bProgressVisible = bFlag;

	m_nFrameCnt = 0;
}