//=============================================================================
// PlayerChar.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerChar.h"
#include "Manipulator.h"
#include "MapManager.h"
#include "Item.h"
#include "DataManager.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerChar::CPlayerChar(void)
{
	RtlZeroMemory( &m_CharInfo, sizeof(m_CharInfo) );
	RtlZeroMemory( &m_BasePram, sizeof(m_BasePram) );
	RtlZeroMemory( &m_Param   , sizeof(m_Param) );
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerChar::~CPlayerChar(void)
{
}
//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CPlayerChar::Create( int nID, int nPicID )
{
	// 
	BOOL bRet = CCharacterObject::Create( nID, nPicID );

	// 퓬Gǂݍ
	bRet &= Load( nPicID );

	// ʒu
	SetPosTile( SCREEN_CENTER_TILE_X, SCREEN_CENTER_TILE_Y, DIRECTION_U );

	// i
	RtlZeroMemory( m_pEquip, sizeof(m_pEquip) );

	// Lv1f[^ݒ
	CDataManager::GetInstance()->LoadLvInfoDataCSV( nID, 1, &m_BasePram );
	sprintf_s( m_CharInfo.szName, CDataManager::GetInstance()->GetCharName( nID ) );
	m_CharInfo.nLV = 1;
	m_CharInfo.nJLV = 1;

	CalcParam();	// p^vZ

	RecoveryHPMP();	// HP/MPS

	return bRet;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CPlayerChar::FrameMove( const CManipulator *pMani, CMapManager *pMapMan  )
{
	CCharacterObject::FrameMove();

	if ( !pMapMan->IsScrolling() )
	{
		// 
		if ( pMani->IsKeyPushed( KEY_INPUT_UP ) )
		{
			m_nDirection = DIRECTION_U;
		}
		else if ( pMani->IsKeyPushed( KEY_INPUT_DOWN ) )
		{
			m_nDirection = DIRECTION_D;
		}
		else if ( pMani->IsKeyPushed( KEY_INPUT_LEFT ) )
		{
			m_nDirection = DIRECTION_L;
		}
		else if ( pMani->IsKeyPushed( KEY_INPUT_RIGHT ) )
		{
			m_nDirection = DIRECTION_R;
		}

		// {^
		if ( pMani->CheckKey( KEY_INPUT_X ) )
		{
			// Ă
			pMapMan->NotifyDecideKey( m_nDirection );
		}

	}
	// sAj (ToDo: 蕨̎lȂ)
	m_nState = ( abs(pMapMan->GetScrollOffset()) % MAP_CHIP_SIZE) / 4;
}
//-----------------------------------------------------------------------------
// L[`FbNȂXV
//-----------------------------------------------------------------------------
void CPlayerChar::FrameMove( CMapManager *pMapMan )
{
	// sAj (ToDo: 蕨̎lȂ)
	m_nState = ( abs(pMapMan->GetScrollOffset()) % MAP_CHIP_SIZE) / 4;
}
//-----------------------------------------------------------------------------
// 
// nChrPos == CHR_POS_MAX ͎
//-----------------------------------------------------------------------------
BOOL CPlayerChar::SetEquipItem( CEquipItem *pEquip, int nChrPos /*= CHR_POS_MAX */  )
{
	int nSetTo = nChrPos;
	if ( nChrPos == CHR_POS_MAX )
	{
		nSetTo = CEquipItem::GetCharPosFromEquipPos( pEquip->nEquipPos );
	}

	// ێ
	m_pEquip[nSetTo] = pEquip;
	printf("[%s]𑕔\n", m_pEquip[nSetTo]->szName );

	return TRUE;
}
//-----------------------------------------------------------------------------
// CalcParam
// x[Xp^Ƒip^vZ
//-----------------------------------------------------------------------------
void CPlayerChar::CalcParam( void )
{
	ZeroMemory( &m_Param, sizeof(m_Param) );

	//  bp^
	// f̊bp^
	m_Param.Base = m_BasePram;
	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{	// ł̃u[Xg
		if ( !m_pEquip[iCnt] )
			continue;	// 

		// x[Xp^
		m_Param.Base.nMaxHP		+= m_pEquip[iCnt]->Param.Base.nMaxHP;
		m_Param.Base.nMaxMP		+= m_pEquip[iCnt]->Param.Base.nMaxMP;
		m_Param.Base.nStrength	+= m_pEquip[iCnt]->Param.Base.nStrength;
		m_Param.Base.nVitality	+= m_pEquip[iCnt]->Param.Base.nVitality;
		m_Param.Base.nSpeed		+= m_pEquip[iCnt]->Param.Base.nSpeed;
		m_Param.Base.nIntellect += m_pEquip[iCnt]->Param.Base.nIntellect;
		m_Param.Base.nPiety		+= m_pEquip[iCnt]->Param.Base.nPiety;
		m_Param.Base.nLuck		+= m_pEquip[iCnt]->Param.Base.nLuck;
	}


	//  p^
	// bp^R
	m_Param.nAttack		= m_Param.Base.nStrength;
	m_Param.nDefence	= m_Param.Base.nVitality;
	m_Param.nMagicDef	= m_Param.Base.nPiety;
	m_Param.nParry		= (int)(m_Param.Base.nLuck * 0.1);
	m_Param.nMagicPar	= m_Param.Base.nPiety + (int)(m_Param.Base.nLuck * 0.1);
	m_Param.nWeight		= 0;	// d 0
	m_Param.nHitRate	= 100;	// 100%

	for ( int iCnt = 0; iCnt < CHR_POS_MAX; iCnt ++ )
	{	// ł̃u[Xg
		if ( !m_pEquip[iCnt] )
			continue;	// 

		m_Param.nAttack   += m_pEquip[iCnt]->Param.nAttack;
		m_Param.nDefence  += m_pEquip[iCnt]->Param.nDefence;
		m_Param.nMagicDef += m_pEquip[iCnt]->Param.nMagicDef;
		m_Param.nParry	  += m_pEquip[iCnt]->Param.nParry;
		m_Param.nMagicPar += m_pEquip[iCnt]->Param.nMagicPar;
		m_Param.nWeight	  += m_pEquip[iCnt]->Param.nWeight;

		double dblRate = (double)m_Param.nHitRate / 100;
		dblRate *= ((double)m_pEquip[iCnt]->Param.nHitRate / 100);
		m_Param.nHitRate = (int)dblRate * 100;
	}
}
